<template>
  <ui-input
    class="ui-password-input [&_input]:pr-10 [&_input]:lg:pr-12 [&_input]:xl:pr-14 [&_input_+_div]:right-3 [&_input_+_div]:lg:right-4"
    v-bind="{ ...$attrs, ...filteredProps }"
    :type="visible ? 'text' : 'password'"
  >
    <template #label>
      <slot name="label" />
    </template>
    <template #hints>
      <slot name="hints" />
    </template>
    <template v-if="$slots.iconLeft" #iconLeft>
      <slot name="iconLeft" />
    </template>
    <template #iconRight>
      <!-- type="button" is required to prevent the default type="submit" if used within a form element -->
      <button
        class="pointer-events-auto -mr-2 -mt-2 rounded-full p-2 hover:bg-gray-100 focus:bg-violet-200 focus:text-violet-700 focus:outline-none group-[.has-errors:focus-within]:text-red-700 group-[.has-errors:focus-within]:focus:bg-red-200 group-[.has-errors:focus-within]:focus:text-red-800"
        role="switch"
        type="button"
        :aria-checked="visible ? 'true' : 'false'"
        :aria-label="computedToggleLabel"
        @click="visible = !visible"
      >
        <eye-slash-icon v-if="visible" />
        <eye-icon v-else />
      </button>
    </template>
    <template #errors>
      <slot name="errors" />
    </template>
  </ui-input>
</template>

<script lang="ts" setup>
import { computed, ref } from 'vue'
import { usePreferredLanguages } from '@vueuse/core'
import { EyeIcon, EyeSlashIcon } from '@heroicons/vue/20/solid'
import { useInputProps } from '../../composables'
import UiInput from './Input.vue'

enum TOGGLE_LABEL {
  DE = 'Passwort anzeigen',
  EN = 'show password',
}

defineOptions({
  name: 'UiPasswordInput',
})

const props = defineProps({
  // eslint-disable-next-line vue/valid-define-props
  ...useInputProps(),
  toggleLabel: {
    type: String,
    default: '',
  },
})

const filteredProps = computed(() => {
  const { toggleLabel, ...filteredProps } = props
  return filteredProps
})

const visible = ref(false)

const languages = usePreferredLanguages()
const computedToggleLabel = computed(() => {
  if (props.toggleLabel) {
    return props.toggleLabel
  }

  if (['de-DE', 'de'].includes(languages.value[0])) {
    return TOGGLE_LABEL.DE
  }

  return TOGGLE_LABEL.EN
})
</script>
